import rospy

from typing import Optional

{% for d in data %}
from {{ skillset }}_managers.srv import Get{{ d.name|capitalize }}Data
{% endfor %}

{% for d in data %}
class {{ d.name|data_name }}Data:
    def __init__(self, **kwargs):
        self.__name = '{{ d.name }}'
        self.__client = rospy.ServiceProxy("data/get_{}".format('{{ d.name }}'), Get{{ d.name|data_name }}Data)

    @property
    def name(self) -> str:
        return self.__name

    def ready(self) -> bool:
        return self.wait_manager(timeout=0.1)

    def wait_manager(self, timeout: Optional[float] = None) -> bool:
        try:
            rospy.logdebug(f"Data {self.__name} wait for manager server")
            self.__client.wait_for_service(timeout=timeout)
            return True
        except rospy.ROSException:
            return False

    def __nonzero__(self):
        return self.ready()

    def __bool__(self):
        return self.ready()

    def __call__(self):
        return self.get()

    def get(self):
        rospy.logdebug(f"get data {self.__name}")
        try:
            result = self.__client()
        except rospy.ServiceException:
            return None
        rospy.logdebug("data received")
        rospy.logdebug(f"-- data: {result.data}")
        return result.data
{% endfor %}
